SystemOrganization addCategory: #'GT-Metaceller-Stream'!

Object subclass: #GTCodeTag
	instanceVariableNames: 'codeStream parent currentTag closed isOpen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

GTCodeTag subclass: #GTCascadeTag
	instanceVariableNames: 'first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

!GTCascadeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:56'!
assign: aKey value: aValue
	self first ifFalse:[ self stream nextPut: $; ].
	first := false.
	self nextLine.
	self stream nextPutAll: aKey; nextPutAll: ': '.
	aValue asCodeStringOn: self stream! !

!GTCascadeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 11:34'!
first
	^first ifNil: [ true ]! !

!GTCascadeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:59'!
receiver: aString
	self stream nextPutAll: aString! !

!GTCascadeTag methodsFor: 'generation' stamp: 'DiegoLont 3/31/2014 14:20'!
withBlock: aBlock
	| blockTag |
	self stream nextPutAll: ' with: '.
	blockTag := GTBlockTag on: self codeStream.
	self open: blockTag.
	aBlock value.
	self close! !

!GTCascadeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 12:11'!
withValue: aString 
	self stream nextPutAll: ' with: '.
	aString asCodeStringOn: self stream! !

!GTCodeTag class methodsFor: 'instance creation' stamp: 'DiegoLont 3/31/2014 10:47'!
on: aStream
	^self new
		codeStream: aStream;
		yourself! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:35'!
afterOpenSubTag! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 14:23'!
beforeOpenSubTag
	self open! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:55'!
close
	self closed ifFalse: [ 
		self currentTag ifNotNilDo: [ :tag | tag close ].
		self closeTag.
		closed := true ]! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 10:51'!
closeTag! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:02'!
closeTag: aTag
	aTag = self currentTag ifTrue: [ 
		self currentTag close.
		currentTag := nil ]! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 11:14'!
closed
	^closed ifNil: [ false ]! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 10:47'!
codeStream
	^ codeStream! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 13:54'!
codeStream: anObject
	codeStream := anObject.
	parent := codeStream openTag! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 12:10'!
currentOpenTag
	self currentTag ifNil: [ ^self ].
	^self currentTag currentOpenTag! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 13:49'!
currentTag
	currentTag ifNil: [ ^nil ].
	currentTag closed ifTrue: [ currentTag := nil ].
	^ currentTag! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:26'!
currentTag: aTag
	self openSubTag.
	currentTag := aTag
! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 11:30'!
isOpen
	^isOpen ifNil: [ false ]! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:54'!
nextLine
	self parent
		ifNil: [ 
			self stream cr.
			self putTabs ]
		ifNotNil: [ self parent nextLine ]! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 14:23'!
open
	self isOpen ifFalse: [ self openTag ].
	isOpen := true.! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:48'!
open: aTag
	self open.
	self currentTag ifNil: [ self currentTag: aTag. ^aTag ].
	^self currentTag open: aTag! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:32'!
openSubTag
	self beforeOpenSubTag.
	self afterOpenSubTag! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:23'!
openTag! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 13:55'!
parent
	^ parent! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:05'!
putTabs
	self stream tab.
	self currentTag ifNotNilDo: [ :tag | tag putTabs ]! !

!GTCodeTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 10:49'!
stream
	^ codeStream stream! !

!GTCodeTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:14'!
with: aBlock
	aBlock value.
	self close! !

GTCodeTag subclass: #GTCommentTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

!GTCommentTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:43'!
assign: aKey value: aValue
	self nextLine.
	self stream nextPutAll: aKey; nextPutAll: ': '.
	aValue asCodeStringOn: self stream.
	self stream nextPut: $;.
! !

!GTCommentTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:42'!
closeTag
	self nextLine.
	self stream nextPut: $"! !

!GTCommentTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:23'!
openTag
	self stream nextPut: $"! !

!GTCommentTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:30'!
string: aString
	self open.
	self stream nextPutAll: aString.
	self stream nextLine! !

GTCodeTag subclass: #GTStatementListTag
	instanceVariableNames: 'first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

GTStatementListTag subclass: #GTBlockTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

!GTBlockTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 14:09'!
closeTag
	self stream space; nextPut: $]! !

!GTBlockTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 14:22'!
openTag
	super openTag.
	self stream nextPut: $[
! !

GTStatementListTag subclass: #GTMethodTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

!GTMethodTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 12:13'!
method: aMethodName version: aVersionName importedVersions: aCollection 
	self stream nextPutAll: aMethodName; nextPutAll: ' aSpec'; cr;
		tab; nextPutAll: '<version: '.
	aVersionName asCodeStringOn: self stream.
	aCollection ifNotEmpty: [ 
		self stream nextPutAll: ' imports: '.
		aCollection asCodeStringOn: self stream ].
	self stream nextPut: $>! !

!GTMethodTag methodsFor: 'convenience' stamp: 'DiegoLont 3/31/2014 12:13'!
methodNameFor: aString
	(aString endsWith: 'baseline') ifTrue: [ 
		^(('baseline', (aString copyFrom: 1 to: (aString size-8))) asLegalSelector) greaseString, ':' ].
	^('version', aString) asLegalSelector greaseString, ':'! !

!GTMethodTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:50'!
version: aString importedVersions: aCollection 
	self method: (self methodNameFor: aString) version: aString importedVersions: aCollection! !

GTStatementListTag subclass: #GTPlaformTag
	instanceVariableNames: 'blockOpen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

!GTPlaformTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 13:47'!
blockOpen
	^blockOpen ifNil: [ false ]! !

!GTPlaformTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:48'!
closeTag
	self blockOpen ifTrue: [ 
		self stream space; nextPut: $].
		blockOpen := false ]! !

!GTPlaformTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:48'!
platformName: aPlatformName
	self stream nextPutAll: 'aSpec for: '.
	aPlatformName asSymbol asCodeStringOn: self stream.
	self stream nextPutAll: ' do: ['.
	blockOpen := true.! !

!GTStatementListTag methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 13:49'!
beforeOpenSubTag
	super beforeOpenSubTag.
	self first ifFalse:[ self stream nextPut: $. ].
	self nextLine.
	first := false! !

!GTStatementListTag methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 11:56'!
first
	^first ifNil: [ true ]! !

Object subclass: #GTMetacellerCodeStream
	instanceVariableNames: 'stream currentTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Stream'!

!GTMetacellerCodeStream class methodsFor: 'instance creation' stamp: 'DiegoLont 3/31/2014 10:26'!
on: aStream
	^self new
		stream: aStream;
		yourself! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:15'!
close
	self currentTag ifNotNilDo: [ :t | t close ]! !

!GTMetacellerCodeStream methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 11:04'!
currentTag
	^ currentTag! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:51'!
method: aMethodName versionName: aVersionName importedVersions: aCollection 
	^self openMethod
		method: aMethodName version: aVersionName importedVersions: aCollection;
		yourself! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 10:50'!
open: aTag
	self currentTag ifNil: [ ^currentTag := aTag ].
	^self currentTag open: aTag! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 10:53'!
openCascade
	^self open: (GTCascadeTag on: self)! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:24'!
openComment
	^self open: (GTCommentTag on: self)! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 10:49'!
openMethod
	^self open: (GTMethodTag on: self)! !

!GTMetacellerCodeStream methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 12:10'!
openTag
	self currentTag ifNil: [ ^nil ].
	^self currentTag currentOpenTag! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:18'!
startCascade: aString 
	^self openCascade
		receiver: aString;
		yourself! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:42'!
startComment: aString 
	^self openComment
		string: aString;
		yourself! !

!GTMetacellerCodeStream methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 10:26'!
stream
	^ stream! !

!GTMetacellerCodeStream methodsFor: 'accessing' stamp: 'DiegoLont 3/31/2014 10:26'!
stream: anObject
	stream := anObject! !

!GTMetacellerCodeStream methodsFor: 'generating' stamp: 'DiegoLont 3/31/2014 11:17'!
version: aString importedVersions: aCollection
	^self openMethod
		version: aString importedVersions: aCollection;
		yourself! !
